#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QDebug>
#include <QToolBar>
#include <QFileDialog>
#include <QFileSystemModel>
#include <QStringListModel>
#include <QStringListModel>
#include <QMessageBox>
#include <QLabel>
#include <QTableWidget>
#include <QPushButton>

#include "widget.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE


class ExitDialog : public QDialog
{
    Q_OBJECT
public:
    ExitDialog(QStringList unsavedfiles);

    //!!! Что в классе делают открытые поля??

    QTableWidget *table;
    QLabel *label;
    QPushButton *yes;
    QPushButton *no;
    QPushButton *cancel;

    enum status{YES,NO,CANCEL};

protected:
    void keyPressEvent(QKeyEvent *e) override;
};

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private:
    Ui::MainWindow *ui;

    int createFileTab(bool isnewfile, const QString &filepath);
    void saveFile(int index);
    void saveFileAs(int index);
    void closeFileTab(int index);
    void setupConnection(Widget* file, bool toconnect);

    QStringList openedfiles;


public slots:
    void onCurrentPathChanged(QString oldpath, QString newpath);

private slots:
    void on_treeView_doubleClicked(const QModelIndex &index);
    void on_listView_doubleClicked(const QModelIndex &index);

    void onNewFile();
    void onOpenFile();
    void onSaveFile();
    void onSaveFileAs();
    void onSaveAllFiles();
    void onCloseFile();
    void onCloseAllFiles();
    void onQuit();

    void onShowExplorer(bool checked);
    void onShowViewer(bool checked);

signals:
    void onCut();
    void onCopy();
    void onPaste();
    void onDelete();
    void onSelectAll();

protected:
    void closeEvent(QCloseEvent *event) override;

};

#endif // MAINWINDOW_H
